// NEED Optmum.ext in /include
/*--------------------------------------------------------------------------
 * Optmum.ox - Optimization functions mapped from Gauss to Ox
 *--------------------------------------------------------------------------*/
#ifndef OPTMUM_INCLUDED
#define OPTMUM_INCLUDED

#pragma array_base(1)

#include <oxstd.h>

#ifdef GNUDRAW
  #include <packages/gnudraw/gnudraw.h>
#else
  #include <oxdraw.h>
#endif

#import <maximize>

Out_Optmum(const par, const parnames) 
{ 
	println("%29s", "Coefficient", "%11s", "Gradient"); 
	for (decl i = 1; i < sizer(par)+1; ++i)								 
       	println("%-17s", string(parnames[i]), "%#12.6f", par[i][1],"%#11.6f", par[i][2]); 
} 

namespace gauss {

decl _opmiter=-1;
decl __title=" ";
decl _opalgr=0;
decl _opgdprc=0;
decl _ophsprc=0;
decl _opparnm=<>;
decl _opitdta=0;
/*decl __output=0; declared in ols, see g2ox.ox*/

optset()
{
	_opmiter=-1;
	__title=" ";
	_opalgr=0;
	_opgdprc=0;
	_ophsprc=0;
	_opparnm=<>;
	_opitdta=0;
	__output=1;
}
static decl g_numder5func;
static decl g_analder5func;
static decl g_amhess2func;
static decl g_x;
static decl m_cRobustLL;
g_numder5map(const vP, const adFunc, const avScore, const amHessian)
{
    adFunc[1] = -g_numder5func(vP);
    if (avScore)
		avScore[1] = -g_analder5func(vP)';
    if (amHessian)
 		amHessian[1] = -g_amhess2func(vP);		// TO BE VERIFIED
	return 1;	
}

static decl vP;
static decl m_vGrad;
static decl m_dLL;
static decl m_mCovar;
static decl resp;

optprt(const proc,...)
{
	decl parnames,i;
	if ((_opparnm==<>)||(rows(_opparnm)!=rows(vP)))
	{
		parnames = sprint(1);
		for (i=2; i < rows(vP)+1; ++i)		parnames |= sprint(i);
	}
	else
		parnames=_opparnm;
	Out_Optmum(vP~meanc(m_vGrad), parnames);	
	return { vP, -m_dLL/rows(m_vGrad), meanc(m_vGrad), resp };
}

gradfd(const f, const vp)
{
	gradp(f, vp);
}
optmum(const f, const vp)
{
    decl mhess,hs;
	decl m_vStdErrors,parnames;
	decl Tstat,mpar,i,ir;
    g_numder5func = f;
    g_analder5func = _opgdprc;
	g_amhess2func = _ophsprc;
	
	m_cRobustLL=0;
	MaxControl(_opmiter,__output);
	vP=vp;

//	ScoreContrib(g_numder5map, vP, &m_vGrad);
//	if (Num2Derivative(g_numder5map, vP, &mhess)) 
//	println("In OXGAUSS");
//	println("-g_numder5func(vP):",-g_numder5func(vP));
//	println("-g_analder5func(vP):",-g_analder5func(vP));
//	println("m_vGrad:",m_vGrad);
//	println("mhess:",mhess);
//	println("-g_amhess2func(vP):",-g_amhess2func(vP));
//	exit(0);
	decl time = timer();   
	oxwarning(0);
	if (isfunction(g_amhess2func))
	{
		MaxControl(20, 0);
		resp=MaxBFGS(g_numder5map, &vP, &m_dLL, 0, !isfunction(g_analder5func));			
		MaxControl(_opmiter, __output);
		resp=MaxNewton(g_numder5map, &vP, &m_dLL, &g_amhess2func, 0);
	}
	else
		resp=MaxBFGS(g_numder5map, &vP, &m_dLL, 0, !isfunction(g_analder5func));
	oxwarning(-1);

	if (__output)
	{
	    println(string(__title));
		println("Value of objective function: ",-m_dLL);
		println(" ");
		if ((isfunction(g_analder5func))&&(isfunction(_ophsprc)))
			println(MaxConvergenceMsg(resp)," using analytical first derivatives and hessian ");
		else if (isfunction(g_analder5func)&&(!isfunction(_ophsprc))) 
			println(MaxConvergenceMsg(resp)," using analytical first derivatives ");
		else
			println(MaxConvergenceMsg(resp)," using numerical first derivatives ");
	}
	if (isfunction(g_analder5func))
	   	m_vGrad=-g_analder5func(vP);
	else
//		ScoreContrib(g_numder5map, vP, &m_vGrad);
		m_vGrad=gradp(g_numder5func,vP);
	_opitdta=zeros(2,1);	
	_opitdta[2]=(timer()-time)/6000;
//    _opitdta[1] = "Number of iterations" TO BE DONE 
//    _opitdta[2] "Minutes to convergence"
//    _opgtol, _oprteps

	return { vP, -m_dLL/rows(m_vGrad), meanc(m_vGrad), resp };
}

}
//#endif